tomo/Makefile

116 lines
4.9 KiB
Makefile
Raw Normal View History

PREFIX=$(HOME)/.local
2024-03-09 20:44:52 -08:00
VERSION=0.0.1
2025-03-28 12:23:11 -07:00
CC=cc
2025-03-21 12:32:32 -07:00
CCONFIG=-std=c2x -Werror -D_XOPEN_SOURCE=700 -D_POSIX_C_SOURCE=200809L -fPIC -I. \
-fno-signed-zeros -fno-finite-math-only -fno-signaling-nans -fno-trapping-math \
2024-12-30 12:32:08 -08:00
-fsanitize=signed-integer-overflow -fno-sanitize-recover -fvisibility=hidden -fdollars-in-identifiers \
-DGC_THREADS
2024-03-03 12:04:36 -08:00
LTO=-flto=auto -fno-fat-lto-objects -Wl,-flto
LDFLAGS=
2024-02-04 12:23:59 -08:00
# MAKEFLAGS := --jobs=$(shell nproc) --output-sync=target
CWARN=-Wall -Wextra -Wno-format -Wshadow \
-Wno-pedantic \
-Wno-pointer-arith \
-Wsign-conversion -Wtype-limits -Wunused-result -Wnull-dereference \
2025-03-21 12:32:32 -07:00
-Walloc-zero -Walloca -Wcast-align -Wcast-align=strict \
-Wdangling-else -Wdate-time -Wdisabled-optimization -Wdouble-promotion -Wduplicated-branches \
-Wduplicated-cond -Wexpansion-to-defined -Wno-float-equal \
-Wframe-address -Winline -Winvalid-pch -Wjump-misses-init \
-Wlogical-op -Wmissing-format-attribute -Wmissing-include-dirs -Wmissing-noreturn \
-Wnull-dereference -Woverlength-strings -Wpacked -Wpacked-not-aligned \
-Wredundant-decls -Wshadow -Wshadow=compatible-local -Wshadow=global -Wshadow=local \
-Wsign-conversion -Wno-stack-protector -Wsuggest-attribute=const -Wsuggest-attribute=noreturn -Wsuggest-attribute=pure -Wswitch-default \
-Wsync-nand -Wtrampolines -Wundef -Wunused -Wunused-but-set-variable \
-Wunused-const-variable -Wunused-local-typedefs -Wunused-macros -Wvariadic-macros -Wvector-operation-performance \
-Wwrite-strings
2024-02-04 12:23:59 -08:00
OSFLAGS != case $$(uname -s) in *BSD|Darwin) echo '-D_BSD_SOURCE';; Linux) echo '-D_GNU_SOURCE';; *) echo '-D_DEFAULT_SOURCE';; esac
EXTRA=
G=-ggdb
O=-Og
CFLAGS=$(CCONFIG) $(EXTRA) $(CWARN) $(G) $(O) $(OSFLAGS) $(LTO)
2025-03-28 13:16:04 -07:00
CFLAGS_PLACEHOLDER="$$(printf '\033[2m<flags...>\033[m\n')"
2025-03-28 11:22:42 -07:00
LDLIBS=-lgc -lcord -lm -lunistring -lgmp
2025-03-21 18:48:53 -07:00
COMPILER_OBJS=$(patsubst %.c,%.o,$(wildcard src/*.c))
STDLIB_OBJS=$(patsubst %.c,%.o,$(wildcard src/stdlib/*.c))
TESTS=$(patsubst test/%.tm,test/results/%.tm.testresult,$(wildcard test/*.tm))
2024-02-04 12:23:59 -08:00
all: build/libtomo.so build/tomo
2024-02-04 12:23:59 -08:00
2025-03-21 18:48:53 -07:00
build/tomo: $(STDLIB_OBJS) $(COMPILER_OBJS)
@mkdir -p build
@echo $(CC) $(CFLAGS_PLACEHOLDER) $(LDFLAGS) $^ $(LDLIBS) -o $@
2024-10-29 23:16:39 -07:00
@$(CC) $(CFLAGS) $(LDFLAGS) $^ $(LDLIBS) -o $@
2024-02-04 12:23:59 -08:00
2025-03-21 18:48:53 -07:00
build/libtomo.so: $(STDLIB_OBJS)
@mkdir -p build
2025-03-28 11:22:42 -07:00
@echo $(CC) $^ $(CFLAGS_PLACEHOLDER) $(OSFLAGS) -lgc -lcord -lm -lunistring -lgmp -Wl,-soname,libtomo.so -shared -o $@
@$(CC) $^ $(CFLAGS) $(OSFLAGS) -lgc -lcord -lm -lunistring -lgmp -Wl,-soname,libtomo.so -shared -o $@
2024-02-11 22:48:45 -08:00
tags:
2025-03-21 19:06:45 -07:00
ctags src/*.[ch] src/stdlib/*.[ch]
2024-02-04 12:23:59 -08:00
%.o: %.c src/ast.h src/environment.h src/types.h
@echo $(CC) $(CFLAGS_PLACEHOLDER) -c $< -o $@
2024-10-29 23:16:39 -07:00
@$(CC) $(CFLAGS) -c $< -o $@
2025-03-18 02:15:58 -07:00
%: %.tm
tomo -e $<
test/results/%.tm.testresult: test/%.tm build/tomo
@mkdir -p test/results
2024-09-03 12:14:08 -07:00
@printf '\x1b[33;1;4m%s\x1b[m\n' $<
@set -o pipefail; \
if ! VERBOSE=0 COLOR=1 LC_ALL=C CC=gcc ./build/tomo -O 1 $< 2>&1 | tee $@; then \
2024-09-03 12:14:08 -07:00
rm -f $@; \
false; \
fi
test: $(TESTS)
2025-03-28 13:16:04 -07:00
@printf '\x1b[32;7m ALL TESTS PASSED! \x1b[m\n'
2024-02-23 10:31:35 -08:00
2024-02-04 12:23:59 -08:00
clean:
2025-03-21 18:48:53 -07:00
rm -rf build/* $(COMPILER_OBJS) $(STDLIB_OBJS) test/*.tm.testresult test/.build examples/.build examples/*/.build
2024-02-04 12:23:59 -08:00
%: %.md
2025-03-21 18:52:12 -07:00
pandoc --lua-filter=docs/.pandoc/bold-code.lua -s $< -t man -o $@
2024-02-04 12:23:59 -08:00
examples: examples/base64/base64 examples/ini/ini examples/game/game \
2025-03-18 02:15:58 -07:00
examples/tomodeps/tomodeps examples/tomo-install/tomo-install examples/wrap/wrap examples/colorful/colorful
2025-03-21 19:07:31 -07:00
./build/tomo -qIL examples/commands examples/shell examples/base64 examples/log examples/ini examples/vectors examples/game \
2025-03-18 14:31:17 -07:00
examples/http examples/threads examples/tomodeps examples/tomo-install examples/wrap examples/pthreads examples/colorful
./build/tomo examples/learnxiny.tm
deps: check-gcc
2025-03-21 20:33:22 -07:00
./install_dependencies.sh
check-gcc:
@GCC_VERSION=$$(gcc --version | awk '{print $$3;exit}'); \
if [ "$$(printf '%s\n' "$$GCC_VERSION" "12.0.0" | sort -V | head -n 1)" = "12.0.0" ]; then \
printf "\033[32;1mGCC version is good!\033[m\n"; \
exit 0; \
else \
printf "\033[31;1mGCC version is lower than the required 12.0.0!\033[m\n" >&2; \
exit 1; \
fi
install: build/tomo build/libtomo.so
@if ! echo "$$PATH" | tr ':' '\n' | grep -qx "$(PREFIX)/bin"; then \
printf "\033[31;1mError: '$(PREFIX)' is not in your \$$PATH variable!\033[m\n" >&2; \
printf "\033[31;1mSpecify a different prefix with 'make PREFIX=... install'\033[m\n" >&2; \
printf "\033[31;1mor add the following line to your .profile:\033[m\n" >&2; \
printf "\n\033[1mexport PATH=\"$(PREFIX):\$$PATH\"\033[m\n\n" >&2; \
exit 1; \
fi
2024-03-09 21:03:21 -08:00
mkdir -p -m 755 "$(PREFIX)/man/man1" "$(PREFIX)/bin" "$(PREFIX)/include/tomo" "$(PREFIX)/lib" "$(PREFIX)/share/tomo/modules"
2025-03-21 18:48:53 -07:00
cp -v src/stdlib/*.h "$(PREFIX)/include/tomo/"
cp -v build/libtomo.so "$(PREFIX)/lib/"
2024-03-09 20:44:52 -08:00
rm -f "$(PREFIX)/bin/tomo"
cp -v build/tomo "$(PREFIX)/bin/"
2025-03-21 18:50:03 -07:00
cp -v docs/tomo.1 "$(PREFIX)/man/man1/"
2024-03-09 20:44:52 -08:00
uninstall:
2024-03-09 21:03:21 -08:00
rm -rvf "$(PREFIX)/bin/tomo" "$(PREFIX)/include/tomo" "$(PREFIX)/lib/libtomo.so" "$(PREFIX)/share/tomo"; \
2024-03-09 20:44:52 -08:00
.SUFFIXES:
.PHONY: all clean install uninstall test tags examples deps check-gcc